Subject: [dispatch] Proposed CBOR / CDDL WG

From: Alexey Melnikov <[email-masked]>
Date: Tue, 18 Oct 2016 15:58:22 +0100

Hi,
I received a request to form a new WG that will work on revising CBOR 
(RFC 7049), finishing CDDL and working on a couple of CBOR extensions.

Please comment on the proposed charter and proposed work.

---------

Concise Binary Object Representation (CBOR, RFC 7049) extends the 
JavaScript Object Notation (JSON, RFC 7159) data model to include binary 
data and an extensibility model, using a binary representation format 
that is easy to parse correctly. It has been picked up by a number of 
IETF efforts (e.g., COSE, GRASP) as a message format.

The CBOR working group will update RFC 7049 to fix verified errata. 
Security issues and clarifications may be addressed, but changes to the 
document will ensure backward compatibility for popular deployed 
codebases. The resulting document will be targeted at becoming an 
Internet Standard.

Similar to the way ABNF (RFC 5234/7405) can be used to describe the set 
of valid messages in a text representation, it would be useful if 
protocol specifications could use a description format for the data in 
CBOR-encoded messages.  The CBOR data definition language (CDDL) is a 
proposal for such a description technique that has already been used 
successfully in COSE, GRASP, and efforts outside the IETF.  The CBOR WG 
will complete the development of this specification by creating an RFC 
that can be used as a normative reference in a protocol specification.

In parallel to the work on CDDL, the WG will examine the
Internet-Drafts draft-jroatch-cbor-tags and draft-bormann-cbor-tags-oid that
use CBOR's extensibility mechanisms to provide additional data types as 
used in certain applications.  Where these proposals are deemed useful 
and do not require significant new
development, the CBOR WG might complete these specifications as well.
---------

Best Regards,
Alexey, as an ART AD.

---

From: Paul Kyzivat <[email-masked]>
Date: Tue, 18 Oct 2016 16:48:52 -0400

Alexey,

> IETF efforts (e.g., COSE, GRASP) as a message format.

Is CBOR intended to simply be an alternative encoding for JSON?

> that can be used as a normative reference in a protocol specification.

ISTM it would be good if a single schema representation was applicable 
to both JSON and CBOR.

	Thanks,
	Paul

> _______________________________________________
> dispatch mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dispatch
>

---

From: "John Levine" <[email-masked]>
Date: 18 Oct 2016 22:46:27 -0000

>Is CBOR intended to simply be an alternative encoding for JSON?

My recollection is that during the discussion of CBOR, the authors
said rather firmly that although CBOR has obvious resemblances to
JSON, it's not JSON.  If you look at both of them, you can see that
CBOR already has all sorts of stuff beyond is in JSON, such as a
distinction between integer and floating point values, and semantic
tags that let you say things like this string represents a date.

Perhaps Paul and Carsten could clarify here.

>ISTM it would be good if a single schema representation was applicable 

I see why one would want that, but given the existing semantic
differences between JSON and CBOR, I doubt it's feasible.

R's,
John

---

From: Sean Leonard <[email-masked]>
Date: Tue, 18 Oct 2016 15:57:54 -0700

> differences between JSON and CBOR, I doubt it's feasible.

John is correct.

Additionally, it can be said that CBOR is a "superset" of JSON, in that 
the semantic content of JSON texts [RFC7159] are representable in native 
CBOR.

"Possible" for a JSON+CBOR schema yes; "feasible" no. Additionally, JSON 
schema technology already exists.already.

Best regards,

Sean

---

From: Paul Kyzivat <[email-masked]>
Date: Tue, 18 Oct 2016 20:35:50 -0400

> schema technology already exists.already.

I know. That is why I asked. It seems like it might be evolved to serve 
both, even if one is richer than the other.

	Thanks,
	Paul

---

From: Ira McDonald <[email-masked]>
Date: Wed, 19 Oct 2016 08:53:59 -0400

Hi,

+1 to the proposed charter, speaking as someone who has been
using CBOR (and the evolving CDDL) in three non-IETF standards
bodies for two years (TCG, IEEE, and SAE).

In these other standards efforts the strong typing on the wire of
CBOR and extreme compactness are the primary attractions.
The evolving CDDL is a powerful schema language that shows
promise for excellent runtime validation of complex messages.

Cheers,
- Ira

Ira McDonald (Musician / Software Architect)
Co-Chair - TCG Trusted Mobility Solutions WG
Chair - Linux Foundation Open Printing WG
Secretary - IEEE-ISTO Printer Working Group
Co-Chair - IEEE-ISTO PWG Internet Printing Protocol WG
IETF Designated Expert - IPP & Printer MIB
Blue Roof Music / High North Inc
http://sites.google.com/site/blueroofmusic
http://sites.google.com/site/highnorthinc
mailto: [email-masked]
Jan-April: 579 Park Place  Saline, MI  48176  734-944-0094
May-Dec: PO Box 221  Grand Marais, MI 49839  906-494-2434

On Tue, Oct 18, 2016 at 10:58 AM, Alexey Melnikov <[email-masked]
> wrote:

> Hi,
> I received a request to form a new WG that will work on revising CBOR (RFC
> 7049), finishing CDDL and working on a couple of CBOR extensions.
>
> data and an extensibility model, using a binary representation format that
> is easy to parse correctly. It has been picked up by a number of IETF
> efforts (e.g., COSE, GRASP) as a message format.
>
> document will ensure backward compatibility for popular deployed codebases.
> The resulting document will be targeted at becoming an Internet Standard.
>
> Similar to the way ABNF (RFC 5234/7405) can be used to describe the set of
> valid messages in a text representation, it would be useful if protocol
> specifications could use a description format for the data in CBOR-encoded
> messages.  The CBOR data definition language (CDDL) is a proposal for such
> a description technique that has already been used successfully in COSE,
> GRASP, and efforts outside the IETF.  The CBOR WG will complete the
> development of this specification by creating an RFC that can be used as a
> normative reference in a protocol specification.
>
> used in certain applications.  Where these proposals are deemed useful and
> do not require significant new

---

From: Jaime Jiménez <[email-masked]>
Date: Thu, 20 Oct 2016 13:01:42 +0000

Hi,

+1 to this as well. 

One comment, isn’t  RFC7049 normative already? Is CDDL’s normative doc the one missing?

Ciao,
- - Jaime Jiménez

> On 19 Oct 2016, at 15:53, Ira McDonald <[email-masked]> wrote:
> 
> Hi,
> 
> http://sites.google.com/site/blueroofmusic <http://sites.google.com/site/blueroofmusic>
> http://sites.google.com/site/highnorthinc <http://sites.google.com/site/highnorthinc>
> mailto: [email-masked] <mailto:[email-masked]>
> On Tue, Oct 18, 2016 at 10:58 AM, Alexey Melnikov <[email-masked] <mailto:[email-masked]>> wrote:
> Hi,
> I received a request to form a new WG that will work on revising CBOR (RFC 7049), finishing CDDL and working on a couple of CBOR extensions.
> 
> Concise Binary Object Representation (CBOR, RFC 7049) extends the JavaScript Object Notation (JSON, RFC 7159) data model to include binary data and an extensibility model, using a binary representation format that is easy to parse correctly. It has been picked up by a number of IETF efforts (e.g., COSE, GRASP) as a message format.
> 
> The CBOR working group will update RFC 7049 to fix verified errata. Security issues and clarifications may be addressed, but changes to the document will ensure backward compatibility for popular deployed codebases. The resulting document will be targeted at becoming an Internet Standard.
> 
> Similar to the way ABNF (RFC 5234/7405) can be used to describe the set of valid messages in a text representation, it would be useful if protocol specifications could use a description format for the data in CBOR-encoded messages.  The CBOR data definition language (CDDL) is a proposal for such a description technique that has already been used successfully in COSE, GRASP, and efforts outside the IETF.  The CBOR WG will complete the development of this specification by creating an RFC that can be used as a normative reference in a protocol specification.
> 
> use CBOR's extensibility mechanisms to provide additional data types as used in certain applications.  Where these proposals are deemed useful and do not require significant new
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/dispatch <https://www.ietf.org/mailman/listinfo/dispatch>
>

---

From: Cullen Jennings <[email-masked]>
Date: Sun, 23 Oct 2016 20:25:42 -0600

> On Oct 18, 2016, at 8:58 AM, Alexey Melnikov <[email-masked]> wrote:
> 
> 

Would it be possible to write this up in a way that said what the WG would accomplish vs which drafts it would adopt ?